/*
 * Copyright 2004-present Facebook. All Rights Reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may
 * not use this file except in compliance with the License. You may obtain
 * a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 * License for the specific language governing permissions and limitations
 * under the License.
 */
package com.facebook.watchman;

import java.io.IOException;
import java.io.InputStream;
import java.util.Map;

public interface Deserializer {

  /**
   * Reads the next object from the InputSteram, blocking until it becomes available.
   * @param stream the stream to read from
   * @return a deserialized object, read from the stream
   */
  Map<String, Object> deserialize(InputStream stream) throws IOException;
}
